#include <linux/module.h>	/* Needed by all modules */
#include <linux/kernel.h>	/* Needed for KERN_INFO */
#include <linux/init.h>		/* Needed for the macros */

MODULE_AUTHOR("Alessandro Barenghi");
MODULE_DESCRIPTION("A parametrised module");
MODULE_LICENSE("GPL");

static int parametrised_module_input = 0;
static int parametrised_module_answer;
static int parametrised_module_array[2]={105,-105};
static int parametrised_module_array_count=0;
/*
 * module_param(foo, int, 0000)
 * The first param is the parameters name
 * The second param is it's data type
 * The final argument is the permissions bits, 
*/
module_param(parametrised_module_input,int,0600);
module_param_array(parametrised_module_array,int,&parametrised_module_array_count,0000);

static int __init startup(void)
{
    int i=0;
    printk(KERN_INFO "Loading sample module...\n");
    printk(KERN_INFO "Module Loaded\nInput was %d, Computing Answer",parametrised_module_input);
    parametrised_module_answer=42;
    printk(KERN_INFO "The Answer is %d\n",parametrised_module_answer);
    printk(KERN_INFO "I received an array containing :\n");
    for (i=0;i<parametrised_module_array_count;i++){
	printk(KERN_INFO "Cell %d, value %d\n",i,parametrised_module_array[i]);
	}
    return 0;
}

static void __exit shutdown(void)
{
    printk(KERN_INFO "Unplugging module\n");
}

module_init(startup);
module_exit(shutdown);
