#include <linux/module.h>
#include <linux/slab.h>
#include <linux/mm.h>
#include <linux/init.h>
#include <linux/timex.h>
#include <linux/types.h>
#include <asm/msr.h>
#include <linux/vmalloc.h>

MODULE_LICENSE("GPL");

#define NALLOC 1000
static void *pointers[NALLOC];

static void testalloc(int size)
{
	int free0, free1, i;
	struct sysinfo info;
	u32 tsc0, tsc1;

	si_meminfo(&info);
	free0 = info.freeram;
	rdtscl(tsc0);
	for (i=0; i<NALLOC; i++)
		pointers[i] = vmalloc(size);
	rdtscl(tsc1);
	si_meminfo(&info);
	free1 = info.freeram;
	for (i=0; i<NALLOC; i++)
		vfree(pointers[i]);
	printk("size %6i: free was %6i, now %6i (delta %6i) time %4ius\n", size, free0, free1,free1-free0, (tsc1-tsc0)/(cpu_khz/1000));
}

int kmt_init(void)
{
	int sizes[]={1,2,5,0};
	struct sysinfo info;
	int i, j;
	
	si_meminfo(&info);
	printk("Vmalloc test\nfree %li (unit %i)\n", info.freeram, info.mem_unit);
	for(i = 1; i <= 100*1000; i*=10)
		for (j=0; sizes[j]; j++)
			testalloc(i*sizes[j]);
	return 0;
}

void kmt_exit(void) {} /* unused */

module_init(kmt_init);
module_exit(kmt_exit);
